/***************************************************************************\
  "global.h" - Global Variables and Functions (Global Phase)
  Revision 4; 10 Nov 2002 - 21 Nov 2002
  Copyright (C) 2002  Kevin P. Albrecht
\***************************************************************************/

#ifndef GLOBAL_H
#define GLOBAL_H

/////////////////////////
// DEFINES //////////////
/////////////////////////

// External Defines //
// GLOBAL_DEBUG or GLOBAL_NODEBUG

/////////////////////////
// INCLUDES /////////////
/////////////////////////

// Standard //

// Local //
#include "global_conv.h"

/////////////////////////
// DEFINITIONS //////////
/////////////////////////

int gnIndent;            // current indentation level
int gnCurrentLine;       // current line number
char *gsCurrentFilename; // hold current filename for error reporting
int gnTables;
int gnErrors;            // syntax errors
bool gbVerbose;          // output verbose debug messages

//// global_init
//// Initialize global variables
void global_init ()
{
  gnIndent = 0;
  gnCurrentLine = 0;
  gsCurrentFilename = k_new (256);
  gnTables = 0;
  gnErrors = 0;
  gbVerbose = false;
}

void global_deinit ()
{
  k_del (gsCurrentFilename);
}

void debug (char *s)
{
  #ifdef GLOBAL_DEBUG
    if (!s) printf ("<NIL>\n");
    else printf ("<%s>\n", s);
  #endif
}

void debugc (char c)
{
  #ifdef GLOBAL_DEBUG
    printf ("<%c>\n", c);
  #endif
}

void debugs (char *s1, char *s2)
{
  #ifdef GLOBAL_DEBUG
    //int i;

    if (!s2) printf ("%s; <NIL>\n", s1);
    else printf ("%s; %s\n", s1, s2);

    //printf ("%s: ", s1);
    //for (i = 0; i < 10; i++)
    //{
    //  printf("%d<%c>, ", s2[i], s2[i]);
    //}
    //printf ("\n");
  #endif
}

#endif
